//+------------------------------------------------------------------+
//|                                             VelocityExpert_v1mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

//---- input parameters
extern string     Expert_Name    = "VelocityExpert_v1";

extern int        Magic          = 10000;
extern int        Slippage       =     6;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =   0.1;
extern double     TakeProfit     =     0;    // Take Profit Value 
extern double     InitialStop    =     0;    // Initial Stop Value
extern double     TrailingStop   =    25;    // Trailing Stop Value 
extern int        SessionStart   =     0;    // Start Hour of Trade Session 
extern int        SessionEnd     =    24;    // End Hour of Trade Session
 
extern string     Inputs         = " Velocity parameters ";
extern int        TimeFrame      =     0;    // Large Time Frame in min
extern int        VelocityPeriod =     8;    // Period of Velocity
extern int        Slow           =     5;    // Period of Slow line
extern int        MA_Mode        =     1;    // Mode of MA

extern string     MM_inputs      = " MoneyManagement by L.Williams ";
extern bool       MM             = false;    //  Switch
extern double     MMRisk         =  0.15;    // Risk Factor
extern double     MaxLoss        =  1000;    // Maximum Loss by 1 Lot

int      OrderBar=0;
double   SellStop,BuyStop,SellProfit,BuyProfit, Lotsi;
bool     SignalMail=false;
bool     FirstTime=false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
  OrderBar = iBars(Symbol(),TimeFrame);  
//----
   return(0);
  }

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

int TradeSignal()
{   
   int signal=0;
   
   double vel   = iCustom(Symbol(),TimeFrame,"Velocity_v2",VelocityPeriod,Slow,MA_Mode,0,1);
   double slow  = iCustom(Symbol(),TimeFrame,"Velocity_v2",VelocityPeriod,Slow,MA_Mode,1,1);
   
   double prevvel   = iCustom(Symbol(),TimeFrame,"Velocity_v2",VelocityPeriod,Slow,MA_Mode,0,2);
   double prevslow  = iCustom(Symbol(),TimeFrame,"Velocity_v2",VelocityPeriod,Slow,MA_Mode,1,2);
      
   if (TimeHour(CurTime()) >= SessionStart && TimeHour(CurTime()) <= SessionEnd)
   {
   if ( prevvel < prevslow && vel > slow ) signal= 1;
   if ( prevvel > prevslow && vel < slow ) signal=-1;
   }
   return(signal);
}

double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   Lotsi=Lots;
	    
   if ( flag ) Lotsi=Lots*NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
      
   return(Lotsi);
}   


void TrailStop()
{
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			double BuyStop = Bid - TrailingStop*Point;
			   if( OrderOpenPrice() <= BuyStop || OrderStopLoss() == 0 ) 
            {   
			      if ( BuyStop > OrderStopLoss() ) 
			      {
			      OrderModify(OrderTicket(),OrderOpenPrice(),
			                  NormalizeDouble(BuyStop, Digits),
			                  OrderTakeProfit(),0,LightGreen);
			         if( GetLastError()>0 )
                  {
                  Print("BUY: OrderModify failed with error #",GetLastError());
                  }
			      return(0);
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         double SellStop = Ask + Point * TrailingStop;   
            if( OrderOpenPrice() > SellStop) 
            {
               if( OrderStopLoss() > SellStop || OrderStopLoss() == 0 ) 
               {
               OrderModify(OrderTicket(), OrderOpenPrice(),
                           NormalizeDouble(SellStop, Digits),
			                  OrderTakeProfit(),0,DarkOrange);
                  if( GetLastError()>0 )
                  {
                  Print("SELL: OrderModify failed with error #",GetLastError());
                  }
               return(0);
               }   
   			}	    
         }
      }
   }     
}

// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
        	  
   if (InitialStop > 0) SellStop  = StopPrice + InitialStop*Point; 
	else SellStop = 0;
   if (TakeProfit  > 0) SellProfit = SellPrice - TakeProfit*Point; 
   else SellProfit=0;
   
	int ticket = OrderSend( Symbol(),Mode,MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                        NormalizeDouble(SellPrice , Digits),
	                        Slippage,
	                        NormalizeDouble(SellStop  , Digits),
	                        NormalizeDouble(SellProfit, Digits),
	                        Expert_Name+" SELL",Magic,0,Red);
   
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		OrderBar =iBars(OrderSymbol(),TimeFrame);
		Print("SELL order opened : ", OrderOpenPrice());
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
		}
   }
	else 	
   if(GetLastError()>0)
   Print("SELL: OrderSend failed with error #",GetLastError());
   
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
      
   if (InitialStop > 0) BuyStop  = StopPrice - InitialStop*Point; 
	else BuyStop = 0;
   if (TakeProfit  > 0) BuyProfit= BuyPrice + TakeProfit*Point;  
   else BuyProfit=0;  
		 
	int ticket = OrderSend(Symbol(),Mode, MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                   NormalizeDouble(BuyPrice , Digits),
	                   Slippage,
	                   NormalizeDouble(BuyStop  , Digits), 
	                   NormalizeDouble(BuyProfit, Digits),
	                   Expert_Name+" BUY",Magic,0,Blue);
      
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		OrderBar =iBars(OrderSymbol(),TimeFrame); 
		Print("BUY order opened : ", OrderOpenPrice());
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		}
   }
	else 	
   if(GetLastError()>0)      
   Print("BUY : OrderSend failed with error #",GetLastError());

   return(0);
} 

//---- Close of Orders
bool CloseOrder(int mode)
{
   for (int i=0; i <= OrdersTotal(); i++)  
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (Symbol()!=OrderSymbol() && OrderMagicNumber()!=Magic) continue;
      
      if((mode==0 || mode==1) && OrderType()==OP_BUY ) 
      {
      OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Aqua);
      if (GetLastError()>0 ) {RefreshRates(); continue;} 
      }
      if((mode==0 || mode==2) && OrderType()==OP_SELL)
      {
      OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
      if (GetLastError()>0 ) {RefreshRates(); continue;}
      }
   }   
return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(iBars(Symbol(),TimeFrame)< 100 || IsTradeAllowed()==false) return; 
      
   if(AccountFreeMargin()< 1000*MoneyManagement ( MM, Lots, MMRisk, MaxLoss))
   {
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);  
   }
   
   if(ScanTrades()==1 && TrailingStop>0) TrailStop();
    
   if (iBars(Symbol(),TimeFrame)!= OrderBar)
   {
      if (TradeSignal()>0) 
      {
         if (ScanTrades()==1) {CloseOrder(2); BuyOrdOpen();}
         else
         if (ScanTrades()==0) BuyOrdOpen();
      }
      
      if (TradeSignal()<0) 
      {
         if (ScanTrades()==1) {CloseOrder(1); SellOrdOpen();}
         else
         if (ScanTrades()==0) SellOrdOpen();
      }   
   }
   
   
  
//----
   return(0);
} //start()
//+------------------------------------------------------------------+